<template lang="pug">
.markdown.slide-content(v-html='mark', :class='customClasses')
</template>

<script>
var taskLists = require('markdown-it-task-lists');
const md = require('markdown-it')({ html: true }).use(taskLists, { enabled: true });

// ::: s-fieldname:Title // sequence data

// ::: fieldname:Title // meeting level data

let regex = /^:::\s(s-)?(\w*):.*$/gm;

export default {
  name: 'Markdown',
  props: {
    content: {
      required: true,
    },
    demo: {
      default: false,
    },
    sequenceinputs: {},
    meetinginputs: {},
  },
  methods: {
    getInput(type, field) {
      if (type === 's-') return this.sequenceinputs[field] || '';
      else return this.meetinginputs[field] || '';
    },
    getInputDemo(type, field) {
      return `<div class="demo-field"><span class="demo-type">${
        type === 's-' ? 'Sequence Input' : 'Meeting Input'
      }</span><span class="demo-name">${field}</span></div>`;
    },
  },
  data() {
    return {
      // classes: [],
    };
  },
  computed: {
    customClasses() {
      //strip off first line (if its a classname)
      // let tmp = {};
      if (this.content) {
        let classes = [];
        // console.log(this.content);
        let content = this.content.toString();
        if (content.startsWith('.')) classes = content.split('\n')[0].split('.');

        return classes;
      } else return [];
    },
    mark() {
      try {
        //replace the input content here:
        let inputs = [...this.content.matchAll(regex)];

        let tmp = this.content.toString();

        for (let field of inputs) {
          if (!this.demo) tmp = tmp.replace(field[0], `> ${md.utils.escapeHtml(this.getInput(field[1], field[2]))}  `);
          else tmp = tmp.replace(field[0], this.getInputDemo(field[1], field[2]));
        }

        if (tmp.startsWith('.')) {
          tmp = tmp.split('\n').slice(1).join('\n');
        }

        return md.render(tmp);
      } catch {
        return this.content;
      }
    },
  },
};
</script>
